/*
 * qml.h
 *
 *
 * declaration of all shared functions and variables of qml.c
 *
 * by Korbinian Strimmer and Arndt von Haeseler (1995-96)
 * this file belongs to the Puzzle version 2.4 distribution 
 *
 */


EXTERN char **Identif;   /* taxa names                                        */
EXTERN char **Seqchar;   /* ML sequence data                                  */
EXTERN double *Freqtpm;  /* base frequencies                                  */
EXTERN double AlphaBeta; /* Ts rate / Tv rate                                 */
EXTERN double AlphaYR;   /* Y-Ts rate / R-Ts rate                             */
EXTERN int Converg;      /* flag for ML convergence                           */
EXTERN int data_optn;    /* type of sequence input data                       */  
EXTERN int Dayhf_optn;   /* Dayhoff model                                     */
EXTERN int Jtt_optn;     /* JTT model                                         */
EXTERN int Maxsite;      /* number of ML characters per taxum                 */
EXTERN int Maxspc;       /* number of taxa                                    */
EXTERN int mtrev_optn;   /* mtREV model                                       */
EXTERN int nuc_optn;     /* nucleotide (4x4) models                           */
EXTERN int Numit;        /* number of ML iterations if there is convergence   */
EXTERN int SH_optn;      /* SH nucleotide (16x16) model                       */

char *int2code(int s);                             /* state -> code           */
double quartet_alklhd(int a, int b, int c, int d); /* compute approximate ML  */
double quartet_lklhd(int a, int b, int c, int d);  /* compute ML (a,b)-(c,d)  */
int code2int(cvector c);                           /* code -> state           */
int getcodelength();                               /* length of code          */
int gettpmradix();                                 /* number of states        */
void dyhfdata(double **a, double *f);              /* Dayhoff model           */
void jttdata(double **a, double *f);               /* JTT model               */
void mtrevdata(double **a, double *f);             /* mtREV model             */
void qmlfinish();                                  /* finish ML analysis      */
void qmlstart();                                   /* start ML analysis       */
void updatetpm();                                  /* update ML engine        */

